/*NB_REVISION*/

/*NB_COPYRIGHT*/

#ifndef _FORM_TOOL_H_
#define _FORM_TOOL_H_

/**
 * @brief ShowIP2Sock
 *
 * @param sock
 * @param ip
 */
void ShowIP2Sock(int sock, IPADDR ip);

/**
 *   Functions to manage HTML form creation.
 */

/**
 * @brief Output a selection
 *
 * @param sock
 * @param name
 * @param selnum
 * @param list
 *
 * Item 1 = First selection item!
 */
void FormOutputSelect(int sock, const char *name, int selnum, const char **list);

/**
 * @brief Output a selection value
 *
 * @param sock
 * @param name
 * @param selnum
 * @param labellist
 * @param valuelist
 * @param onclicklist
 */
void FormOutputSelectValueOnClick(int sock,
                                  const char *name,
                                  int selnum,
                                  const char **labellist,
                                  const char **valuelist,
                                  const char **onclicklist);

/**
 * @brief Output a check box
 *
 * @param sock
 * @param name
 * @param checked
 */
void FormOutputCheckbox(int sock, const char *name, BOOL checked);

/**
 * @brief Output an input box
 *
 * @param sock
 * @param name
 * @param siz
 * @param val
 */
void FormOutputInput(int sock, const char *name, int siz, const char *val);

/**
 * @brief Output an input box for numbers
 *
 * @param sock
 * @param name
 * @param siz
 * @param val
 */
void FormOutputNumInput(int sock, const char *name, int siz, int val);

/**
 * @brief Output an input box for IP addresses
 *
 * @param sock
 * @param name
 * @param ip
 */
void FormOutputIPInput(int sock, const char *name, IPADDR ip);

#endif /* _FORM_TOOL_H_ */
