/*NB_REVISION*/

/*NB_COPYRIGHT*/

#ifndef _NB_FACTORY_H_
#define _NB_FACTORY_H_

/*
 ******************************************************************************
 *
 * Factory defaults for this factory application
 *
 ******************************************************************************
 */
/* Configuration verify key (increment if data changed, added, reorganized) */
#define NB_FACTORY_VERIFY_KEY (0x7E545085)
/* STD-EFFS verify key (increment to format file system, required for 1.6-1.9 STD EFFS Upgrade) */
#define STD_EFFS_VERIFY_KEY (0x15A58101)

/* Version  VV.NN.vvvv ( 0xVVNNvvvv ), string must match constant  */
#define NB_FACTORY_DEFAULTS_VERSION (uint32_t)(0x01000000)
#define NB_FACTORY_DEFAULTS_VERSION_STRING "01.00.0000"

/* Module Base Name */
#if defined MOD5441X
#define NB_FACTORY_MODULE_BASE_NAME "MOD5441X"
#elif defined NANO54415
#define NB_FACTORY_MODULE_BASE_NAME "NANO54415"
#elif defined SB800EX
#define NB_FACTORY_MODULE_BASE_NAME "SB800EX"
#elif defined MODM7AE70
#define NB_FACTORY_MODULE_BASE_NAME "MODM7AE70"
#elif defined SBE70LC
#define NB_FACTORY_MODULE_BASE_NAME "SBE70LC"
#else
#error Module not supported
#endif

/* Module Description */
#define NB_FACTORY_BASE_DESC "SSL/TLS"

/* Feature Name and Description */
#define NB_FACTORY_FEATURE_NAME "SX"
#define NB_FACTORY_FEATURE_DESC "Certificate Upload Example"

/* SSH */
#define NB_FACTORY_INCLUDE_SSH (1)

/* SSL */
#define NB_FACTORY_SSL_PERMANENT_DESC_DEFAULT "Not Installed"
#define NB_FACTORY_SSL_INCLUDED_DESC_DEFAULT "Default "
#define NB_FACTORY_SSL_INSTALLED_DESC_DEFAULT "User Installed "

#define NB_FACTORY_SSL_FILE_NAME_CERT "cert.crt"
#define NB_FACTORY_SSL_FILE_NAME_KEY "cert.key"

/* DHCP timeout */
#define NB_FACTORY_DHCP_TIMEOUT_IN_TICKS (10 * TICKS_PER_SECOND)

/*
 * Maximum size of certificate or key files in bytes
 *    Must the maximum of
 *       SERIAL_BURNER_CERTIFICATE_SIZE_MAX
 *       SERIAL_BURNER_RSA_KEY_SIZE_MAX
 *       SERIAL_BURNER_DSA_KEY_SIZE_MAX
 */
#define NB_FACTORY_FILE_SIZE_MAXIMUM (4 * 1024)

/*
 * On-chip file system EFFS-STD
 *    COMPCODEFLAGS end address must be set to file system start
 *    (FIRST_ADDR)
 */

/* Module unique flash parameters */
#if defined MOD5441X
/* Flash */
#define NB_FACTORY_FLASH_32MB_128KB_SECTORS (1)
/* Base address */
#define NB_FACTORY_FS_FLASHBASE (0xC0000000)
/* See makefile for COMPCODEFLAGS */

#elif (defined NANO54415) || (defined SB800EX)
/* Flash */
#define NB_FACTORY_FLASH_SPI_8MB_4KB_SECTORS (1)
/* Base address */
//#define NB_FACTORY_FS_FLASHBASE              ( 0x040000 )  // not used for spi flash
/* See makefile for COMPCODEFLAGS */

#elif ((defined MODM7AE70) || (defined SBE70LC))
/* Flash */
#define NB_FACTORY_FLASH_2MB_8KB_SECTORS (1)
/* Base address */
#define NB_FACTORY_FS_FLASHBASE (0x00400000)

#else
#error Module not supported
#endif

#endif /* #ifdef _NB_FACTORY_H_ */
