/*NB_REVISION*/

/*NB_COPYRIGHT*/

//* NB Library Definitions */
#include <http.h>
#include <httppost.h>
#include <netbios.h>

/* Product Definitions */
#include "nbfactory.h"

/* Ethernet to Serial Application Definitions */
#include "serialburnerdata.h"

#ifdef DIAG_LOG
#include "log.h"
#endif /* #ifdef DIAG_LOG */

/* Close down system before updating configuration */
extern void CloseEverything(void);

/* Verify entered password with user parameter settings password */
extern int TestPassword(const char *name, const char *passwd);

/* certificatekey.cpp routines */
extern void CaCertPost(int sock, PostEvents event, const char *pName, const char *pValue);
extern void HttpsPost(int sock, PostEvents event, const char *pName, const char *pValue);
extern void CaDelPost(int sock, PostEvents event, const char *pName, const char *pValue);

// Register a call back for the web page...
HtmlPostVariableListCallback gHttpsPostCallback("HTTPSPOST.HTML", HttpsPost);
HtmlPostVariableListCallback gCaCertPostCallback("CACERTPOST.HTML", CaCertPost);
HtmlPostVariableListCallback gCaDelPostCallback("CADELPOST.HTML", CaDelPost);

/**
 * @brief Checks for changes with user parameters.
 */
void CheckForChanges()
{
    // Check for changes
    if (gChangedUserParameters == (BOOL) true)
    {
        OSTimeDly(1);

        // Save changes
        if (gChangedUserParameters == (BOOL) true)
        {
            debug_iprintf("Saving User Parameters, size = %ld\r\n", sizeof(NV_Settings));
            SaveUserParameters(&gNV_SettingsChangeCopy, sizeof(NV_Settings));
            NV_SettingsStruct *NV_SettingsStructPtr = (NV_SettingsStruct *)GetUserParameters();
            NV_Settings = *NV_SettingsStructPtr;
            gChangedUserParameters = false;
        }
    }
}
