/*NB_REVISION*/

/*NB_COPYRIGHT*/

#ifndef _SSLUSER_H_
#define _SSLUSER_H_

/* NB Secure Sockets Layer (SSL)  */
#include <crypto/ssl.h>

/* Default or installed user PEM encoded certificate */
extern char gSslCert[(SERIAL_BURNER_CERTIFICATE_SIZE_MAX_PEM + 1)];
extern char gSslKey[(SERIAL_BURNER_KEY_SIZE_MAX_PEM + 1)];

#ifdef __cplusplus
extern "C"
{
#endif

    /**
     * @brief Checks and installs SSL default certificate and key.
     *
     * <b>Notes:</b> Sets NV_Settings elements:
     *   - SslCertificateSource;
     *   - SslCertificateLength;
     *   - SslKeyLength;
     */
    void SslUserSetDefault(void);

    /**
     * @brief Retrieves and set certificate and key.
     *
     * <b>Notes:</b> Clears SSL settings for CertificateNKeysDataStatus element of
     * `struct NV_SettingsStruct` if retrieval error occurs.
     */
    void SslUserRetrieveCertificateNKey(void);

#ifdef __cplusplus
};
#endif

#endif /* _SSLUSER_H_ */
